import { SvelteComponent, init, safe_not_equal, element, append, create_slot, attr, null_to_empty, insert, get_slot_context, get_slot_changes, transition_in, transition_out, detach } from 'svelte/internal';

/* src/lib/Grid.svelte generated by Svelte v3.20.1 */

function add_css() {
	var style = element("style");
	style.id = "svelte-1lpkj1i-style";
	style.textContent = ".container.svelte-1lpkj1i{box-sizing:border-box;display:flex;flex-wrap:wrap;width:calc(100% + (var(--paddingSGR) * 2));margin:var(--marginSGR)}.col.svelte-1lpkj1i{position:relative;box-sizing:border-box;flex-grow:var(--colFlexSGR);padding:var(--paddingSGR)}.col-xs.svelte-1lpkj1i{flex-basis:var(--xsWidthSGR);max-width:var(--xsWidthSGR)}@media(min-width: 576px){.col-sm.svelte-1lpkj1i{flex-basis:var(--smWidthSGR);max-width:var(--smWidthSGR)}}@media(min-width: 768px){.col-md.svelte-1lpkj1i{flex-basis:var(--mdWidthSGR);max-width:var(--mdWidthSGR)}}@media(min-width: 992px){.col-lg.svelte-1lpkj1i{flex-basis:var(--lgWidthSGR);max-width:var(--lgWidthSGR)}}@media(min-width: 1200px){.col-xl.svelte-1lpkj1i{max-width:var(--xlWidthSGR)}}";
	append(document.head, style);
}

function create_fragment(ctx) {
	let div;
	let div_class_value;
	let current;
	const default_slot_template = /*$$slots*/ ctx[14].default;
	const default_slot = create_slot(default_slot_template, ctx, /*$$scope*/ ctx[13], null);

	return {
		c() {
			div = element("div");
			if (default_slot) default_slot.c();
			attr(div, "style", /*styleGeneral*/ ctx[1]);
			attr(div, "class", div_class_value = "" + (null_to_empty(/*classGeneral*/ ctx[0]) + " svelte-1lpkj1i"));
		},
		m(target, anchor) {
			insert(target, div, anchor);

			if (default_slot) {
				default_slot.m(div, null);
			}

			current = true;
		},
		p(ctx, [dirty]) {
			if (default_slot) {
				if (default_slot.p && dirty & /*$$scope*/ 8192) {
					default_slot.p(get_slot_context(default_slot_template, ctx, /*$$scope*/ ctx[13], null), get_slot_changes(default_slot_template, /*$$scope*/ ctx[13], dirty, null));
				}
			}

			if (!current || dirty & /*styleGeneral*/ 2) {
				attr(div, "style", /*styleGeneral*/ ctx[1]);
			}

			if (!current || dirty & /*classGeneral*/ 1 && div_class_value !== (div_class_value = "" + (null_to_empty(/*classGeneral*/ ctx[0]) + " svelte-1lpkj1i"))) {
				attr(div, "class", div_class_value);
			}
		},
		i(local) {
			if (current) return;
			transition_in(default_slot, local);
			current = true;
		},
		o(local) {
			transition_out(default_slot, local);
			current = false;
		},
		d(detaching) {
			if (detaching) detach(div);
			if (default_slot) default_slot.d(detaching);
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let { container = false } = $$props;
	let { gutter = false } = $$props;
	let { xs = false } = $$props;
	let { sm = false } = $$props;
	let { md = false } = $$props;
	let { lg = false } = $$props;
	let { xl = false } = $$props;
	let classGeneral = "";
	let styleGeneral = "";

	const getValue = breakpoint => {
		return breakpoint ? `${breakpoint / 12 * 100}%` : false;
	};

	const createClassSize = () => {
		let newClass = "";
		newClass += xs ? "col-xs " : "";
		newClass += sm ? "col-sm " : "";
		newClass += md ? "col-md " : "";
		newClass += lg ? "col-lg " : "";
		newClass += xl ? "col-xl " : "";
		return newClass;
	};

	const createStyleSize = () => {
		let newStyle = "";
		newStyle += xs ? `--xsWidthSGR:${getValue(xs)}; ` : "";
		newStyle += sm ? `--smWidthSGR:${getValue(sm)}; ` : "";
		newStyle += md ? `--mdWidthSGR:${getValue(md)}; ` : "";
		newStyle += lg ? `--lgWidthSGR:${getValue(lg)}; ` : "";
		newStyle += xl ? `--xlWidthSGR:${getValue(xl)}; ` : "";
		return newStyle;
	};

	const createGutter = () => {
		return gutter
		? `--paddingSGR:${gutter / 2}px;--marginSGR:-${gutter / 2}px`
		: "--paddingSGR:0;--marginSGR:0";
	};

	let { $$slots = {}, $$scope } = $$props;

	$$self.$set = $$props => {
		if ("container" in $$props) $$invalidate(2, container = $$props.container);
		if ("gutter" in $$props) $$invalidate(3, gutter = $$props.gutter);
		if ("xs" in $$props) $$invalidate(4, xs = $$props.xs);
		if ("sm" in $$props) $$invalidate(5, sm = $$props.sm);
		if ("md" in $$props) $$invalidate(6, md = $$props.md);
		if ("lg" in $$props) $$invalidate(7, lg = $$props.lg);
		if ("xl" in $$props) $$invalidate(8, xl = $$props.xl);
		if ("$$scope" in $$props) $$invalidate(13, $$scope = $$props.$$scope);
	};

	$$self.$$.update = () => {
		if ($$self.$$.dirty & /*container, styleGeneral*/ 6) {
			 {
				$$invalidate(0, classGeneral = container ? "container" : `col ${createClassSize()}`);

				if (container) {
					$$invalidate(1, styleGeneral = createGutter());
				} else {
					$$invalidate(1, styleGeneral = createStyleSize());

					if (styleGeneral) {
						$$invalidate(1, styleGeneral += `--colFlexSGR:0;`);
					} else {
						$$invalidate(1, styleGeneral = `--colFlexSGR:1;`);
					}
				}
			}
		}
	};

	return [
		classGeneral,
		styleGeneral,
		container,
		gutter,
		xs,
		sm,
		md,
		lg,
		xl,
		getValue,
		createClassSize,
		createStyleSize,
		createGutter,
		$$scope,
		$$slots
	];
}

class Grid extends SvelteComponent {
	constructor(options) {
		super();
		if (!document.getElementById("svelte-1lpkj1i-style")) add_css();

		init(this, options, instance, create_fragment, safe_not_equal, {
			container: 2,
			gutter: 3,
			xs: 4,
			sm: 5,
			md: 6,
			lg: 7,
			xl: 8
		});
	}
}

export default Grid;
